import { View } from '@tarojs/components'
import { forwardRef, memo, useEffect, useImperativeHandle, useMemo, useRef, useState } from 'react'
import classnames from 'classnames'
import style from './index.module.scss'

interface prosObj {
  obj?: {
    sale_mode?: Number
    collect_status?: Number | string
    status?: Number
    payment_method?: Number
    settle_mode?: Number | string
    is_shipper_picks_up?: boolean
  }
  cancle?: (any) => void
  nextBuy?: (any) => void
  toPay?: (any) => void
  handSureGoods?: () => void
  showTuiGoods?: boolean
  handApplyGoods?: () => void
  handApplyMoney?: () => void
  handShowCodeList?: () => void
  handEdit?: () => void
  showDetail?: boolean
  goodsObj?: any
}

const BottomBtns = (props: prosObj, ref) => {
  const {
    obj = {
      sale_mode: 0,
      collect_status: '',
      status: '',
      payment_method: 0,
      settle_mode: '',
      is_shipper_picks_up: false,
    },
    showTuiGoods = false,
    cancle,
    nextBuy,
    toPay,
    handSureGoods,
    handApplyGoods,
    handApplyMoney,
    handShowCodeList,
    handEdit,
    showDetail = false,
    goodsObj = {},
  } = props
  // 判断显示取消订单

  const showCancel = useMemo(() => {
    if (
      (obj.sale_mode === 0 && obj.status === 0)
            || (obj.sale_mode === 0 && obj.status === 1)
            || (obj.sale_mode === 0 && obj.status === 2 && obj.collect_status == 0)
            || (obj.sale_mode === 0 && obj.status === 7 && obj.collect_status == 0)
            || (obj.sale_mode === 0 && obj.status === 11 && obj.collect_status == 0)
            || (obj.sale_mode === 0 && obj.status === 11 && obj.settle_mode == 3)
            || (obj.sale_mode === 0 && obj.status === 3 && obj.settle_mode == 3)
            || (obj.sale_mode === 1 && obj.status === 10)
            || (obj.sale_mode === 2 && obj.status === 10)
            || (obj.sale_mode === 2 && obj.status === 0 && (obj.collect_status == 1 || obj.collect_status == 2))
            || (obj.sale_mode === 2 && obj.status === 0 && obj.collect_status == 0)
            || (obj.sale_mode === 1 && obj.status === 10)
            || (obj.sale_mode === 2 && obj.status === 10)
             || (obj.sale_mode === 0 && obj.status === 13)
    ) {
      return true
    }
    else { return false }
  }, [obj])
  // 判断显示再次购买
  const showBuy = useMemo(() => {
    if (
      obj.sale_mode === 0
            || (obj.sale_mode === 1 && obj.status !== 10)
            || (obj.sale_mode === 2 && obj.status !== 10)
    ) {
      return true
    }
    else { return false }
  }, [obj])
  // 判断显示去付款
  const canBuy = useMemo(() => {
    if (
      (obj.sale_mode === 0 && obj.status === 7 && obj.collect_status == 1)
            || (obj.sale_mode === 0 && obj.status === 7 && obj.collect_status == 0)
            || (obj.sale_mode === 0 && obj.status === 7 && obj.settle_mode == 3)
            || (obj.sale_mode === 0 && obj.status === 3 && obj.collect_status == 1)
            || (obj.sale_mode === 0 && obj.status === 3 && obj.collect_status == 0)
            || (obj.sale_mode === 0 && obj.status === 8 && obj.collect_status == 1)
            || (obj.sale_mode === 0 && obj.status === 8 && obj.collect_status == 0)
            || (obj.sale_mode === 0 && obj.status === 9 && obj.collect_status == 1)
            || (obj.sale_mode === 0 && obj.status === 9 && obj.collect_status == 0)
            || (obj.sale_mode === 2 && obj.status === 2)
            || (obj.sale_mode === 2 && obj.status === 7)
            || (obj.sale_mode === 1 && obj.status === 10)
            || (obj.sale_mode === 1 && obj.status === 7)
            || (obj.sale_mode === 2 && obj.status === 10)
    ) {
      return true
    }
    else { return false }
  }, [obj])

  // 判断显示确认收货
  const showTake = useMemo(() => {
    if (
      (obj.sale_mode === 0 && obj.status == 8 && obj.collect_status == 0)
            || (obj.sale_mode === 0 && obj.status == 8 && obj.collect_status == 1)
            || (obj.sale_mode === 0 && obj.status == 8 && obj.collect_status == 2)
            || (obj.sale_mode === 0 && obj.status == 8 && obj.settle_mode == 3)
            || (obj.sale_mode === 1 && obj.status == 8)
            || (obj.sale_mode === 2 && obj.status == 8)
    ) {
      return true
    }
    else { return false }
  }, [obj])

  // 判断显示申请退货
  const showTuihuo = useMemo(() => {
    if (
      (obj.sale_mode === 0 && obj.status == 9 && obj.collect_status == 0 && goodsObj?.av_return_product?.length)
            || (obj.sale_mode === 0 && obj.status == 9 && obj.collect_status == 1 && goodsObj?.av_return_product?.length)
            || (obj.sale_mode === 0 && obj.status == 9 && obj.collect_status == 2 && goodsObj?.av_return_product?.length)
            || (obj.sale_mode === 0 && obj.status == 9 && obj.settle_mode == 3 && goodsObj?.av_return_product?.length)
            || (obj.sale_mode === 2 && obj.status == 9 && goodsObj?.av_return_product?.length)
    ) {
      return true
    }
    else { return false }
  }, [obj])
  // 判断显示申请退款
  const showTuikuan = useMemo(() => {
    if (
      (obj.sale_mode === 0 && obj.status == 2 && obj.collect_status == 1 && goodsObj?.av_return_product?.length)
            || (obj.sale_mode === 0 && obj.status == 7 && obj.collect_status == 2 && goodsObj?.av_return_product?.length)
            || (obj.sale_mode === 0 && obj.status == 7 && obj.collect_status == 3 && goodsObj?.av_return_product?.length)
            || (obj.sale_mode === 0 && obj.status == 11 && (obj.collect_status == 1 || obj.collect_status == 2) && goodsObj?.av_return_product?.length)
            || (obj.sale_mode === 0 && obj.status == 3 && obj.collect_status == 0 && goodsObj?.av_return_product?.length && !obj.is_shipper_picks_up)
            || (obj.sale_mode === 0 && obj.status == 3 && obj.collect_status == 2 && goodsObj?.av_return_product?.length && !obj.is_shipper_picks_up)
            || (obj.sale_mode === 0 && obj.status == 3 && obj.collect_status == 1 && goodsObj?.av_return_product?.length && !obj.is_shipper_picks_up)
            || (obj.sale_mode === 1 && obj.status == 0 && goodsObj?.av_return_product?.length)
            || (obj.sale_mode === 1 && obj.status == 9 && goodsObj?.av_return_product?.length)
            || (obj.sale_mode === 2 && obj.status == 0 && obj.collect_status == 1 && goodsObj?.av_return_product?.length)
            || (obj.sale_mode === 2 && obj.status == 0 && obj.collect_status == 2 && goodsObj?.av_return_product?.length)
    ) {
      return true
    }
    else { return false }
  }, [obj])

  // 判断是否显示码单
  // 订单状态：待付款、待发货、待提货、待收货、已收货、已完成
  const showCodeList = useMemo(() => {
    if (obj.status == 3 || obj.status == 8 || obj.status == 11 || obj.status == 9 || obj.status == 4) {
      return true
    }
    else { return false }
  }, [obj])

  // 判断是否显示修改订单
  const showEdit = useMemo(() => {
    if (obj.status == 0 || obj.status == 1) {
      return true
    }
    else {
      return false
    }
  }, [obj])

  // 多的不显示别的按钮
  const [btnList, setbtnList] = useState<any[]>([])
  const itemNums = useMemo(() => {
    const arr: any[] = []
    let nums = 0
    if (showCancel) {
      nums = nums + 1
      console.log('222')
      arr.push({
        key: 'showCancel',
        label: '取消订单',
        bgKind: 1,
        sort: 1,
      })
    }
    if (canBuy) {
      nums = nums + 1
      console.log('333')
      arr.push({
        key: 'canBuy',
        label: '去付款',
        bgKind: 2,
        sort: 20,
      })
    }
    if (showBuy) {
      nums = nums + 1
      console.log('444')
      arr.push({
        key: 'showBuy',
        label: '再次购买',
        bgKind: 3,
        sort: 10,
      })
    }
    if (showTake) {
      nums = nums + 1
      console.log('111')
      arr.push({
        key: 'showTake',
        label: '确认收货',
        bgKind: 1,
        sort: 9,
      })
    }
    if (showCodeList) {
      nums = nums + 1
      console.log('555')
      arr.push({
        key: 'showCodeList',
        label: '销售码单',
        bgKind: 1,
        sort: 12,
      })
    }
    if (showTuikuan) {
      nums = nums + 1
      console.log('666')
      arr.push({
        key: 'showTuikuan',
        label: '申请退款',
        bgKind: 3,
        sort: 3,
      })
    }
    if (showTuihuo) {
      nums = nums + 1
      console.log('777')
      arr.push({
        key: 'showTuihuo',
        label: '申请退货',
        bgKind: 3,
        sort: 2,
      })
    }
    if (showEdit) {
      nums = nums + 1
      console.log('101010')
      arr.push({
        key: 'showEdit',
        label: '修改订单',
        bgKind: 3,
        sort: 9,
      })
    }
    console.log(arr, 'arr')
    const fiterArr = arr.sort((a, b) => a.sort - b.sort)
    setbtnList([...fiterArr])
    return nums
  }, [obj])

  useImperativeHandle(ref, () => ({
    itemNums,
    btnList,
  }))

  const submitBtns = (e, key) => {
    if (key === 'showTuihuo') {
      handApplyGoods?.()
    }
    if (key === 'showTuikuan') {
      handApplyMoney?.()
    }
    if (key === 'showCodeList') {
      handShowCodeList?.()
    }
    if (key === 'showTake') {
      handSureGoods?.()
    }
    if (key === 'showCancel') {
      cancle?.(e)
    }
    if (key === 'showBuy') {
      nextBuy?.(e)
    }
    if (key === 'canBuy') {
      toPay?.(e)
    }
    if (key === 'showEdit') {
      handEdit?.()
    }
  }

  return (
    <View className={style.flexBox}>

      {
        (showDetail || showTuiGoods) && <>
          {
            btnList.map((item, index) =>
              btnList.length - 3 <= index && (
                <View key={index} className={classnames(item.bgKind === 1 ? style.cancle : item.bgKind === 2 ? style.toBuy : style.nextBuy)} onClick={e => submitBtns(e, item.key)}>
                  {item.label}
                </View>
              ),
            )
          }
        </>
      }

      {
        !showDetail && !showTuiGoods && <>
          {
            showCancel && <View className={style.cancle} onClick={e => cancle?.(e)}>取消订单</View>
          }
          {
            showBuy && <View className={style.nextBuy} onClick={e => nextBuy?.(e)}>再次购买</View>
          }
          {
            canBuy && <View className={style.toBuy} onClick={e => toPay?.(e)}>去付款</View>
          }

        </>
      }

    </View>
  )
}
export default memo(forwardRef(BottomBtns))
