import type { InputProps } from '@tarojs/components'
import { CustomWrapper, Input, View } from '@tarojs/components'
import type { FC } from 'react'
import React from 'react'
// 解决 input 组件输入过快会出现闪烁的问题
// https://github.com/NervJS/taro/issues/9664
interface PropsType extends InputProps {
  customClassName?: string
  customStyle?: React.CSSProperties
  customInputStyle?: React.CSSProperties
  customInputClassName?: string
}
const InputX: FC<PropsType> = (props) => {
  const { customClassName, customStyle, customInputStyle, customInputClassName, ...inputProps } = props
  return (
    <View className={customClassName} style={customStyle}>
      <CustomWrapper>
        <Input className={customInputClassName} style={customInputStyle} {...inputProps} ></Input>
      </CustomWrapper>
    </View>
  )
}

export default InputX
