import { Text, View } from '@tarojs/components'
import classNames from 'classnames'
import { useState } from 'react'
import styles from './index.module.scss'
import LayoutBlock from '@/components/layoutBlock'
import IconFont from '@/components/iconfont/iconfont'
import SaleModeTag from '@/components/saleModeTag'
import { EnumSaleMode } from '@/common/Enumerate'
import NormalButton from '@/components/normalButton'
import { goLink } from '@/common/common'

interface PropsType {

}
const TakeGoodsItem = (props: PropsType) => {
  const handleClickAllTake = () => {

  }

  const handleClickItem = (id) => {
    goLink('/pages/takeDeliveryDetail/index', {
      id,
    })
  }

  const [showMore, setShowMore] = useState(false)
  const [dataList, setDataList] = useState([
    {
      id: 1,
      order_no: 'XS-LY-2208220092',
      sale_mode: EnumSaleMode.Bulk,
      color: 2,
      fabric: 1,
      total: 5,
    },
    {
      id: 2,
      order_no: 'XS-LY-2208220092',
      sale_mode: EnumSaleMode.Bulk,
      color: 2,
      fabric: 1,
      total: 5,
    },
    {
      id: 3,
      order_no: 'XS-LY-2208220092',
      sale_mode: EnumSaleMode.Bulk,
      color: 2,
      fabric: 1,
      total: 5,
    },
    {
      id: 4,
      order_no: 'XS-LY-2208220092',
      sale_mode: EnumSaleMode.Bulk,
      color: 2,
      fabric: 1,
      total: 5,
    },
    {
      id: 5,
      order_no: 'XS-LY-2208220092',
      sale_mode: EnumSaleMode.Bulk,
      color: 2,
      fabric: 1,
      total: 5,
    },
  ])

  const handleChangeMore = () => {
    setShowMore(prev => !prev)
  }

  return <LayoutBlock customClassName={styles.layout} flexDirection="col" circle>
    <View className={styles.title_bar}>
      <View className={styles.title}>
        <IconFont name="icon-a-bianzu3beifen" customStyle={{ marginRight: '10rpx' }} size={40} color="#337fff"></IconFont>
        永川纺织有限公司
      </View>
      <View className={styles.status}>采购提货</View>
    </View>
    <View className={classNames(styles.order_list, showMore && styles.showAll)}>
      {
        dataList.map((item) => {
          return <View key={item.id} className={styles.item} onClick={() => handleClickItem(1)}>
            <View className={styles.item_left}>
              <View className={styles.detail_row}>
                <View>单号编号：</View>
                <View className={styles.order_no}>{item.order_no}</View>
              </View>
              <View className={styles.detail_row}>
                <View>货品信息：</View>
                <View className={styles.order_no}><SaleModeTag saleMode={item.sale_mode} size="small" customStyle={{ marginRight: '10rpx' }}></SaleModeTag><Text>{item.fabric}种面料，{item.color}种颜色，共{item.total}条</Text></View>
              </View>
            </View>
            <IconFont customClassName={styles.item_right} name="icon-chakanquanbukehu" size={40} color="#636465"></IconFont>
          </View>
        })
      }
    </View>
    {(dataList.length > 2) && <View className={styles.more} onClick={handleChangeMore}>
      <Text style={{ marginRight: '10rpx' }}>{showMore ? '收起详情' : '点击查看详情'}</Text>
      {
        showMore ? <IconFont name="icon-gengduo" color="#d2d2d2" size={20} customStyle={{ transform: 'rotate(180deg)' }}></IconFont> : <IconFont color="#d2d2d2" name="icon-gengduo" size={20}></IconFont>
      }
    </View>}
    <View className={styles.button}>
      <Text className={styles.total}>2种面料，4种颜色，共5条</Text>
      <NormalButton round customClassName={styles.takeout} plain type="primary" onClick={handleClickAllTake}>确认提货</NormalButton>
    </View>
  </LayoutBlock>
}
export default TakeGoodsItem
